#!/bin/python3
import json

# Open the original JSON file
with open('/srv/big_vault/nicholas/scrapers/AFH/devices.json', 'r') as file:
    data = file.read()

# Split the data into individual JSON objects
json_objects = data.split('\n}{')

# Process each JSON object
for i, json_obj in enumerate(json_objects):
    # Add curly braces to the start and end of each JSON object
    if i == 0:
        json_obj = json_obj + '}'
    elif i == len(json_objects) - 1:
        json_obj = '{' + json_obj
    else:
        json_obj = '{' + json_obj + '}'

    # Parse the JSON object
    try:
        parsed_data = json.loads(json_obj)
        # Write the JSON object to a new file
        with open(f'fixed_{i+1}.json', 'w') as output_file:
            json.dump(parsed_data, output_file, indent=4)
        print(f'Fixed JSON {i+1} written successfully.')
    except json.JSONDecodeError as e:
        print(f'Error parsing JSON {i+1}: {e}')

print('All JSON files fixed.')
