#!/bin/python3
import os
import sys
from bs4 import BeautifulSoup
import requests
import json
import time
import sys
from playwright.sync_api import sync_playwright
#url = 'https://androidfilehost.com/?w=developers&did=51'
#url = 'https://androidfilehost.com/?w=developers&did=3899'
#url= 'https://androidfilehost.com/?w=developers&did=395'
url = sys.argv[1]
response = requests.get(url)
def get_response(url):
    with sync_playwright() as p:
        while True:
            browser = p.firefox.launch(headless=True)
            page = browser.new_page()
            page.goto(url)
            #time.sleep(2)
#            button = page.query_selector('.fc-button.fc-cta-consent.fc-primary-button')
#            page.wait_for_selector(button)
            #button.click()
            #time.sleep(2)
            element_selector = '.row.page-container.page-developers'
            warning_selector = 'b:has-text("Warning")'
            element_or_warning_selector = f'{element_selector}, {warning_selector}'
            page.wait_for_selector(element_or_warning_selector)

            html = page.content()
#        response = requests.get(url, headers=headers)
            if '<b>Warning</b>' not in html:
                break
                print('retrying')

    print('request to ', url, ' sucessful')
    soup = BeautifulSoup(html, "html.parser")
    return soup, html

soup, html = get_response(url)

title = soup.find('h1')
print(title.text)
#print(html)
if "&page=" in response.content.decode('utf-8'):
    print('has multiple pages')
    has_multiple_pages = 'true'
    page_links = soup.find_all('a', href=lambda href: href and "&page=" in href)
    page_list = []
    print(page_links)
    print(url)
    for link in page_links:
        if link.text != '':
            page_list.append(int(link.text))
        last_page = max(page_list)
    print('total of', last_page, 'pages')
else:
    has_multiple_pages = 'false'
    print('page has 1 page')
    last_page = 1
original_url = url
last_page = last_page + 1

dev_pages = {
    "title": title.text
    }
devs_info = []
for page_number in range(1, last_page):
    print('page number = ', page_number)
    url = (original_url + '&page=' + str(page_number))
    print(url)
    soup, html = get_response(url)
    dev_elements = soup.find_all('div', class_='thumbnail tile developer col-md-12 dev-thumb clearfix')
    for dev_element in dev_elements:
        username = dev_element.find('a', href=lambda href: href and "w=profile" in href)
        link = dev_element.find('a', href=lambda href: href and "w=files" in href)
        link = 'https://androidfilehost.com' + link.get('href')
        print('username ', username.text, link)
        dev_info = {
                "username": username.text,
                "url": link
                }
        devs_info.append(dev_info)
#    print(json.dumps(devs_info, indent=4))
dev_pages["devs"] = devs_info
dev_pages_json = json.dumps(dev_pages, indent=4)
print(dev_pages_json)


with open('dev_list.json', 'w') as file:
    file.truncate(0)
    for json_string in dev_pages_json:
        file.write(json_string)










